Subject: bug#47581: 27.1; tab-bar missed mouse clicks on MS-Windows

From: Eli Zaretskii <[email-masked]>
Date: Mon, 12 Apr 2021 05:31:17 +0300

> From: Juri Linkov <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Mon, 12 Apr 2021 00:53:45 +0300
> 
> > I also removed note_tab_bar_highlight and the code which called it.  I
> > couldn't find any place which depended on that, and there was no
> > visible effect of mouse-highlight on any part of the tab-bar buttons
> > that I could see.  If I missed something, please show a recipe where
> > this highlight had any effect before my changes.
> 
> Sorry, I don't understand the need to remove the highlighting code.
> Before the removal, the tab-bar button images reacted to mouse pointer
> movements, and highlighted the buttons under the mouse pointer
> using the pressed/released state DRAW_IMAGE_SUNKEN/RAISED.

I didn't see any such effect, and couldn't find the code which
supports this highlighting.  Please point out what I missed.

> Now there is no visual feedback when the user moves the mouse pointer
> over the buttons.  Doesn't seem like an improvement.

There was no visual feedback before my changes on my system, so I
really don't understand what you are describing.  Were you seeing that
in a GTK build or a build without GTK?

> > (It _is_ possible to have the tab-bar buttons react to mouse pointer
> > movements, but for that we need support in display code, which isn't
> > there.  If we will ever want to add mouse sensitivity to tab-bar
> > buttons, we should first add code which displays those buttons
> > differently when the draw_glyphs_face value is DRAW_MOUSE_FACE or
> > DRAW_IMAGE_SUNKEN/RAISED; then we'd want to resurrect
> > note_tab_bar_highlight that I deleted.)
> 
> Looks like a plan to re-add the same feature, but differently.

>From my POV, the feature was never there.